Imports System.IO
Imports Telerik.WebControls
Imports Telerik.RadUploadUtils.RadControl
Imports Telerik.WebControls.RadTreeViewContextMenu

Partial Class _Default
    Inherits System.Web.UI.Page

    Protected Sub btnSubmit_Click(ByVal sender As Object, ByVal e As EventArgs)
        BindResults()
    End Sub 'btnSubmit_Click

    Private Sub BindTreeToDirectory(ByVal dirPath As String, ByVal parentNode As RadTreeNode)
        Dim dirs As String() = Directory.GetDirectories(dirPath)
        Dim s As String
        For Each s In dirs

            Dim parts As String() = s.Split("\"c)
            Dim name As String = parts((parts.Length - 1))
            If name <> "Examples" And name <> "_vti_cnf" Then
                Dim node As New RadTreeNode(name)
                node.ImageUrl = "Folder.gif"
                node.ImageExpandedUrl = "FolderOpen.gif"
                node.Value = s
                node.Text = name
                node.Category = "Folder"
                node.ContextMenuName = "FolderContextMenu"
                parentNode.Nodes.Add(node)

                BindTreeToDirectory(s, node)
            End If
        Next s

        Dim files As String() = Directory.GetFiles(dirPath)
        Dim fileNAme As String
        For Each fileNAme In files
            Dim parts As String() = fileNAme.Split("\"c)
            Dim name As String = parts((parts.Length - 1))
            Dim node As New RadTreeNode(name)
            Dim fi As New FileInfo(fileNAme)
            node.ImageUrl = "File.gif"
            node.Value = fi.Name & "@" & fi.Length.ToString() & "@" & fi.LastWriteTime.ToString()
            node.Category = dirPath & "\" & fi.Name
            node.ContextMenuName = "FirstContextMenu"
            parentNode.Nodes.Add(node)
        Next fileNAme

    End Sub 'BindTreeToDirectory


    Private Sub BindResults()
        Dim resultsExist As Boolean = upload1.UploadedFiles.Count > 0
        lblNoResults.Visible = Not resultsExist
        rptReqults.Visible = resultsExist
        If resultsExist Then
            rptReqults.DataSource = upload1.UploadedFiles
            rptReqults.DataBind()
        End If
        If Session("type") <> "Admin" Then
            Dim rootFolder As String = Server.MapPath("~/incoming/" & Session("company") & "/")
            Dim rootNode As New RadTreeNode(rootFolder)
            RadTree1.Nodes.Clear()
            rootNode.Text = Session("company")
            rootNode.Value = rootFolder
            rootNode.ImageUrl = "Folder.gif"
            rootNode.ImageExpandedUrl = "FolderOpen.gif"
            rootNode.Category = "Folder"
            rootNode.Expanded = True
            rootNode.ContextMenuName = "RootContextMenu"
            RadTree1.Nodes.Add(rootNode)
            BindTreeToDirectory(rootFolder, rootNode)
        Else
            Dim rootFolder As String = Server.MapPath("~/incoming/")
            Dim rootNode As New RadTreeNode(rootFolder)
            RadTree1.Nodes.Clear()
            rootNode.Text = "Company Folders"
            rootNode.Value = Server.MapPath("~/incoming/")
            rootNode.ImageUrl = "Folder.gif"
            rootNode.ImageExpandedUrl = "FolderOpen.gif"
            rootNode.Category = "Folder"
            rootNode.Expanded = True
            rootNode.ContextMenuName = "RootContextMenu"
            RadTree1.Nodes.Add(rootNode)
            BindTreeToDirectory(rootFolder, rootNode)
        End If
        Dim uploadnode As RadTreeNode = RadTree1.FindNodeByText(Session("company"))
        uploadnode.Expanded = True

        Dim newnode As New RadTreeNode
        newnode.ImageUrl = "13Recycle.gif"
        newnode.Value = "Recycle"
        newnode.Text = "Recycle"
        newnode.Category = "Recycle"
        newnode.DragEnabled = False
        newnode.DropEnabled = True
        RadTree1.Nodes.Add(newnode)
    End Sub 'BindResults

    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        If Not Session("logon_success") Then
            Server.Transfer("default.aspx")
        Else
            Session("logon_success") = True
        End If

        If Session("type") = "Admin" Then
            lblUserAdmin.Visible = True
        End If

        InitializeComponent()
        MyBase.OnInit(e)
    End Sub 'OnInit

    Private Sub InitializeComponent()
        Dim nd As New DirectoryInfo(Server.MapPath(".") & "/incoming/" & Session("company"))
        If nd.Exists = False Then
            nd.Create()
        End If
        upload1.TargetFolder = "~/incoming/" & Session("company") & "/"
    End Sub 'InitializeComponent


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not Page.IsPostBack Then
            If Session("type") <> "Admin" Then
                Dim rootFolder As String = Server.MapPath("~/incoming/" & Session("company") & "/")
                Dim rootNode As New RadTreeNode(rootFolder)
                rootNode.Text = Session("company")
                rootNode.Value = rootFolder
                rootNode.ImageUrl = "Folder.gif"
                rootNode.ImageExpandedUrl = "FolderOpen.gif"
                rootNode.Category = "Folder"
                rootNode.Expanded = True
                rootNode.ContextMenuName = "RootContextMenu"
                RadTree1.Nodes.Add(rootNode)
                BindTreeToDirectory(rootFolder, rootNode)
            Else
                Dim rootFolder As String = Server.MapPath("~/incoming/")
                Dim rootNode As New RadTreeNode(rootFolder)
                rootNode.Text = "Company Folders"
                rootNode.Value = Server.MapPath("~/incoming/")
                rootNode.ImageUrl = "Folder.gif"
                rootNode.ImageExpandedUrl = "FolderOpen.gif"
                rootNode.Category = "Folder"
                rootNode.Expanded = True
                rootNode.ContextMenuName = "RootContextMenu"
                RadTree1.Nodes.Add(rootNode)
                BindTreeToDirectory(rootFolder, rootNode)
            End If
            Dim newnode As New RadTreeNode
            newnode.ImageUrl = "13Recycle.gif"
            newnode.Value = "Recycle"
            newnode.Text = "Recycle"
            newnode.Category = "Recycle"
            newnode.DragEnabled = False
            newnode.DropEnabled = True
            RadTree1.Nodes.Add(newnode)
        End If

        ' Files Menu
        Dim contextMenus As New ArrayList()
        Dim cm As New ContextMenu()
        cm.Name = "FirstContextMenu"
        cm.Width = 150
        contextMenus.Add(cm)
        Dim cmi1 As New ContextMenuItem("Delete File")
        cmi1.PostBack = True
        cmi1.Image = "files_delete_24.gif"
        Dim cmi2 As New ContextMenuItem("Rename File")
        cmi2.PostBack = False
        cmi2.Image = "files_write_24.gif"
        Dim cmi3 As New ContextMenuItem("Download File")
        cmi3.PostBack = True
        cmi3.Image = "files_down_24.gif"
        cm.Items.Add(cmi1)
        cm.Items.Add(cmi2)
        cm.Items.Add(cmi3)

        ' Folders Menu
        Dim FolderCm As New ContextMenu()
        FolderCm.Name = "FolderContextMenu"
        FolderCm.Width = 150
        contextMenus.Add(FolderCm)
        Dim fcmi1 As New ContextMenuItem("Delete Folder")
        fcmi1.PostBack = True
        fcmi1.Image = "folder_delete_24.gif"
        Dim fcmi2 As New ContextMenuItem("Rename Folder")
        fcmi2.PostBack = False
        fcmi2.Image = "folder_write_24.gif"
        Dim fcmi3 As New ContextMenuItem("Create New Folder")
        fcmi3.PostBack = True
        fcmi3.Image = "folder_add_24.gif"
        FolderCm.Items.Add(fcmi1)
        FolderCm.Items.Add(fcmi2)
        FolderCm.Items.Add(fcmi3)

        ' RootNode Menu
        Dim RootCm As New ContextMenu()
        RootCm.Name = "RootContextMenu"
        RootCm.Width = 150
        contextMenus.Add(RootCm)
        Dim rcmi1 As New ContextMenuItem("Create New Folder")
        rcmi1.PostBack = True
        rcmi1.Image = "folder_add_24.gif"
        RootCm.Items.Add(rcmi1)

        RadTree1.ContextMenus = contextMenus

    End Sub


    Protected Sub ContextClicked(ByVal sender As Object, ByVal e As RadTreeNodeEventArgs)
        Dim thenode As RadTreeNode = RadTree1.SelectedNode
        Select Case (e.ContextMenuItemText)
            Case "Delete File"
                Dim parentfolder As String = RadTree1.SelectedNode.Parent.Text
                Dim path As String = Server.MapPath("~/incoming/") & parentfolder & "/" & thenode.Text
                File.Delete(path)
                RadTree1.SelectedNode.Parent.Nodes.Remove(RadTree1.SelectedNode)
            Case "Delete Folder"
                Directory.Delete(thenode.Value)
                RadTree1.SelectedNode.Parent.Nodes.Remove(RadTree1.SelectedNode)
            Case "Create New Folder"
                Directory.CreateDirectory(thenode.Value & "\New Folder")
                BindResults()
        End Select
    End Sub

    Protected Sub RadTree1_NodeClick(ByVal o As Object, ByVal e As Telerik.WebControls.RadTreeNodeEventArgs) Handles RadTree1.NodeClick

    End Sub 'ContextClickedEnd Class

    Dim done As Boolean = True
    Protected Sub RadTree1_NodeDrop(ByVal o As Object, ByVal e As Telerik.WebControls.RadTreeNodeEventArgs) Handles RadTree1.NodeDrop
        Dim dragFrom As RadTreeNode = e.SourceDragNode
        Dim dragTo As RadTreeNode = e.DestDragNode
        done = Not done

        If dragTo.Category = "Recycle" And dragFrom.Category = "Folder" Then
            Dim path = dragFrom.Value
            If Directory.Exists(path) Then
                Directory.Delete(path, True)
                dragFrom.Parent.Nodes.Remove(dragFrom)
                Return
            End If
        End If

        If dragTo.Category = "Recycle" And dragFrom.Category <> "Folder" Then
            Dim path = dragFrom.Category
            If File.Exists(path) Then
                File.Delete(path)
                dragFrom.Parent.Nodes.Remove(dragFrom)
                Return
            End If
        End If

        If Not done Then
            If dragTo.Category = "Folder" And dragFrom.Category <> "Folder" And dragFrom.Parent.Text <> dragTo.Text And dragTo.Text <> "Company Folders" Then
                Dim path1 = dragFrom.Category
                Dim path2 = dragTo.Value & "/" & dragFrom.Text
                If File.Exists(path1) And Not File.Exists(path2) Then
                    File.Move(path1, path2)
                    Dim node As New RadTreeNode
                    node.ImageUrl = dragFrom.ImageUrl
                    node.Value = dragFrom.Value
                    node.Category = path2
                    node.ContextMenuName = dragFrom.ContextMenuName
                    node.Text = dragFrom.Text
                    dragTo.Nodes.Add(node)
                    dragFrom.Parent.Nodes.Remove(dragFrom)
                    Return
                End If
            End If
        End If
    End Sub

    Protected Sub RadTree1_NodeEdit(ByVal o As Object, ByVal e As Telerik.WebControls.RadTreeNodeEventArgs) Handles RadTree1.NodeEdit
        Dim nodeEdited As RadTreeNode = e.NodeEdited
        Dim oldText As String = nodeEdited.Text
        Dim newText As String = e.NewText

        Select Case (nodeEdited.Category)
            Case "Folder"
                Dim path1 As String = nodeEdited.Value
                Dim path2 As String = Replace(path1, nodeEdited.Text, newText)
                If path1 <> path2 Then
                    Directory.Move(path1, path2)
                    nodeEdited.Text = newText
                    nodeEdited.Value = path2
                End If
            Case Else
                Dim parentfolder As String = RadTree1.SelectedNode.Parent.Text
                Dim path1 As String = nodeEdited.Parent.Value & "/" & oldText
                Dim path2 As String = nodeEdited.Parent.Value & "/" & newText
                File.Move(path1, path2)
                nodeEdited.Text = newText
                nodeEdited.Category = path2
        End Select
    End Sub



End Class